// Copyright (C) 2002-2007 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __I_PARTICLE_ROTATION_AFFECTOR_H_INCLUDED__
#define __I_PARTICLE_ROTATION_AFFECTOR_H_INCLUDED__

#include "IParticleAffector.h"

namespace irr
{
namespace scene
{

//! A particle affector modifies particles.
class IParticleRotationAffector : public IParticleAffector
{
public:

	//! Affects an array of particles.
	//! \param now: Current time. (Same as ITimer::getTime() would return)
	//! \param particlearray: Array of particles.
	//! \param count: Amount of particles in array.
	virtual void affect(u32 now, SParticle* particlearray, u32 count) = 0;

	//! Set the point that particles will attract to
	virtual void setPivotPoint( core::vector3df point ) = 0;

	//! Set the speed in degrees per second, for rotation around the X axis
	virtual void setSpeedX( f32 speed ) = 0;

	//! Set the speed in degrees per second, for rotation around the Y axis
	virtual void setSpeedY( f32 speed ) = 0;
	
	//! Set the speed in degrees per second, for rotation around the Z axis
	virtual void setSpeedZ( f32 speed ) = 0;
	
	//! Get the point that particles are attracted to
	virtual const core::vector3df& getPivotPoint() const = 0;

	//! Get the speed in degrees per second, for rotation around the X axis
	virtual const f32& getSpeedX() const = 0;

	//! Set the speed in degrees per second, for rotation around the Y axis
	virtual const f32& getSpeedY() const = 0;

	//! Set the speed in degrees per second, for rotation around the Z axis
	virtual const f32& getSpeedZ() const = 0;
};

} // end namespace scene
} // end namespace irr


#endif // __I_PARTICLE_ROTATION_AFFECTOR_H_INCLUDED__

